<?php
namespace Elbotrade\Bundle\CatalogBundle\Controller;

use Elbotrade\Bundle\CatalogBundle\Controller\CatalogController as CatalogController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;

class CatalogBackendController extends CatalogController
{

    /**
     * @Route("/elbotrade/catalog/backend/list", name="elbotrade_catalog_backend_list")
     * @Template()
     */
    public function indexAction()
    {

        return parent::indexAction(); // TODO: Change the autogenerated stub
    }

    /**
     * @Route("/elbotrade/catalog/backend/show/{id}", name="elbotrade_catalog_backend_show")
     * @Template()
     */
    public function showAction($id)
    {
        return parent::showAction($id); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @param $id
     * @Route("/elbotrade/catalog/backend/update/{id}", name="elbotrade_catalog_backend_update")
     * @Template("ElbotradeCatalogBundle:CatalogBackend:update.html.twig")
     * @return array|\Symfony\Component\HttpFoundation\RedirectResponse
     */
    public function updateAction(Request $request, $id)
    {

        $editId = $request->get('editId');
        if (!preg_match('/^\d+$/', $editId)) {
            $editId = sprintf('%09d', mt_rand(0, 1999999999));
        }
        $existingFiles = $this->get('punk_ave.file_uploader')->getFiles(array('folder' => 'tmp/attachments/' . $editId));

        $catalogFinder = $this->get('elbotrade.catalog_bundle.catalog_finder');

        $catalog = $catalogFinder->findCatalog($id);

        $form = $this->createForm(
            $this->get('elbotrade_catalog.catalog.form.type'), null, ['action' => $this->generateUrl('elbotrade_catalog_backend_update', ['editId' => $editId, 'id' => $id])]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $catalogManager = $this->get('elbotrade.catalog.catalog_manager');
            if ($catalogId = $catalogManager->handleCatalogForm($form, $catalog, $request, $this->get('sylius.context.locale')->getCurrentLocale())) {
                $response = $this->redirect($this->generateUrl('elbotrade_catalog_backend_show', ['id' => $catalogId]));
                return $response;
            }
        }

        $form->setData($catalog);

        return [
            'editId'=> $editId,
            'existingFiles' => $existingFiles,
            'form' => $form->createView(),
            'images' => $catalog->getImages() ? $catalog->getImages() : [],
            'cover' => $catalog->getCover(),
        ];
    }

    /**
     * @param Request $request
     * @return array
     * @Route("/elbotrade/catalog/backend/create", name="elbotrade_catalog_backend_create")
     * @Template();
     */
    public function createAction(Request $request)
    {

        $editId = $request->get('editId');
        if (!preg_match('/^\d+$/', $editId)) {
            $editId = sprintf('%09d', mt_rand(0, 1999999999));
        }
//        $existingFiles = $this->get('punk_ave.file_uploader')->getFiles(array('folder' => 'tmp/attachments/' . $editId));

        $catalog = $this->get('elbotrade.catalog.catalog_manager')->createCatalog();

        $form = $this->createForm(
            $this->get('elbotrade_catalog.catalog.form.type'), null, ['action' => $this->generateUrl('elbotrade_catalog_backend_create')]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $catalogManager = $this->get('elbotrade.catalog.catalog_manager');
            if ($catalogId = $catalogManager->handleCatalogForm($form, $catalog, $request, $this->get('sylius.context.locale')->getCurrentLocale())) {
                $response = $this->redirect($this->generateUrl('elbotrade_catalog_backend_list'));
                return $response;
            }
        }

        return [
            'editId'=> $editId,
//            'existingFiles' => $existingFiles,
            'form' => $form->createView(),
        ];
    }

    /**
     * @Route("/elbotrade/catalog/backend/delete/{id}", name="elbotrade_catalog_backend_delete")
     */
    public function deleteAction($id)
    {

        $catalog = $this->get('elbotrade.catalog_bundle.catalog_finder')->findCatalog($id);

        $this->getDoctrine()->getManager()->remove($catalog);
        $this->getDoctrine()->getManager()->flush();

        $flashService = $this->get('elbotrade_product.services.flash_service');

        $flashService->setFlash('success', 'Catalog Deleted');

        return $this->redirect($this->generateUrl('elbotrade_catalog_backend_list'));
    }

    /**
     * @Route("upload", name="multi-upload")
     */
    public function multiUploadAction(Request $request)
    {
        $editId = $request->get('editId');

        $this->get('elbotrade.catalog.file_uploader')->handleFileUpload(array('folder' => 'tmp/attachments/' . $editId));
    }
}